/*  Header file for evolve.c                               */
#ifndef _EVOLVE_H_
#define _EVOLVE_H_

#include "tree.h"

#define MAX_RATE_CATS 32

extern int numTaxa, numSites, maxPartitions, numPartitions, fileFormat;
extern double gammaShape, proportionInvariable;
extern int numCats, rateHetero, invariableSites;
extern double catRate[MAX_RATE_CATS];
//extern double xiaNeighborRates[400];
//extern double spNeighborRates[400];
extern int indel_fill_aas;

enum {
	NoRates,
	CodonRates,
	GammaRates,
	DiscreteGammaRates
};

enum {
	PHYLIPFormat,
	RelaxedFormat,
	NEXUSFormat
};

/* prototypes */

void SetModel(int model);
void SetCategories();
void CreateRates();
void CreateSequences(TTree *tree, int inNumSites);
void EvolveSequences(TTree *tree, int inFromSite, int inNumSites, double scale, char *ancestor);
void WriteSequences(FILE *fv, int treeNo, int datasetNo, TTree **treeSet, int *partitionLengths);
void WriteAncestralSequences(FILE *fv, TTree *tree);
void WriteRates(FILE *fv);
void WriteMA(FILE *fv, TTree *tree);

#endif /* _EVOLVE_H_ */
